local _, cfg = ...
local addon, ns = ...

if not cfg.SkinUI then return end
--Check if Addon loaded
if not IsAddOnLoaded("BigWigs") then return end

--[[
You can include like any addon, or even embed it into your edit, but there is one limitation. 
The following comment section should never be deleted from !BeautyWigs.lua
************************************************
* Tukui_BigWigs skin by Affli@RU-Howling Fjord *
* All rights reserved.                         *
************************************************
Edited by Game92 @ Wowinterface ( Aftermathhyo @ Steamwheedle Cartel EU // Ellbysaurus @ Aszune EU )
Maintained by 10leej@Wowinterface (Bòb@Korgath // Êo@Korgath)
--]]

BeautyWigs = {}
BeautyWigs["media"] = { 
    ["texture"] = cfg.statusbar_texture,
	["font"] = cfg.font,
}

local playercolor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
-- init some tables to store backgrounds
local freebg = {}
-- Bar Style
local createbg = function()
	local bg = CreateFrame("Frame")
	CreateBorder(bg, 12, 1, 1, 1, 1) -- Add your hooks/skins/backdrops w/e here.
	--bg:Hide()
	return bg
end
-- Castbar Icon Style
local createbgicon = function()
	local bg = CreateFrame("Frame")
	CreateBorder(bg, 12, 1, 1, 1, 1) -- Add your hooks/skins/backdrops w/e here.
	--bg:Hide()
	return bg
end
local function freestyle(bar)
	-- reparent and hide bar background
	local bg = bar:Get("bigwigs:BeautyWigs:bg")
	if bg then
		bg:ClearAllPoints()
		bg:SetParent(UIParent)
		bg:Hide()
		freebg[#freebg + 1] = bg
	end
	-- reparent and hide icon background
	local ibg = bar:Get("bigwigs:BeautyWigs:bg")
	if ibg then
		ibg:ClearAllPoints()
		ibg:SetParent(UIParent)
		ibg:Hide()
		freebg[#freebg + 1] = ibg
	end
	-- replace dummies with original method functions
	bar.candyBarBar.SetPoint = bar.candyBarBar.OldSetPoint
	bar.candyBarIconFrame.SetWidth = bar.candyBarIconFrame.OldSetWidth
	if cfg.BigWigs.disablescaling then 
		bar.SetScale = bar.OldSetScale
	end
end

local applystyle = function(bar)
	-- general bar settings
	bar:SetHeight(cfg.BigWigs.barheight)
	if cfg.BigWigs.disablescaling then
		bar:SetScale(1)
		bar.OldSetScale=bar.SetScale
		bar.SetScale = function() end
	end
	-- create or reparent and use bar background
	local bg = nil
	if #freebg > 0 then
		bg = table.remove(freebg)
	else
		bg = createbg()
	end
	bg:SetParent(bar)
	bg:ClearAllPoints()
	bg:SetPoint("TOPLEFT", bar, "TOPLEFT", -2, 2)
	bg:SetPoint("BOTTOMRIGHT", bar, "BOTTOMRIGHT", 2, -2)
	bg:Show()
	bar:Set("bigwigs:BeautyWigs:bg", bg)
	-- create or reparent and use icon background
	local ibg = nil
	if bar.candyBarIconFrame:GetTexture() then
		if #freebg > 0 then
			ibg = table.remove(freebg)
		else
			ibg = createbgicon()
		end
		ibg:SetParent(bar)
		ibg:ClearAllPoints()
		ibg:SetPoint("TOPLEFT", bar.candyBarIconFrame, "TOPLEFT", -2, 2)
		ibg:SetPoint("BOTTOMRIGHT", bar.candyBarIconFrame, "BOTTOMRIGHT", 2, -2)
		ibg:Show()
		bar:Set("bigwigs:BeautyWigs:bg", ibg)
	end
	-- setup timer and bar name fonts and positions
	bar.candyBarLabel:SetFont(BeautyWigs.media.font, 12, "OUTLINE")
	bar.candyBarLabel:SetShadowColor(0, 0, 0, 0)
	bar.candyBarLabel:SetJustifyH("LEFT")
	bar.candyBarLabel:ClearAllPoints()
	bar.candyBarLabel:SetPoint("BOTTOMLEFT", bar, "TOPLEFT", -2, 5)
	bar.candyBarDuration:SetFont(BeautyWigs.media.font, 12, "OUTLINE")
	bar.candyBarDuration:SetShadowColor(0, 0, 0, 0)
	bar.candyBarDuration:SetJustifyH("RIGHT")
	bar.candyBarDuration:ClearAllPoints()
	bar.candyBarDuration:SetPoint("BOTTOMRIGHT", bar, "TOPRIGHT", 2, 5)
	-- setup bar positions and look
	bar.candyBarBar:ClearAllPoints()
	bar.candyBarBar:SetAllPoints(bar)
	bar.candyBarBar.OldSetPoint = bar.candyBarBar.SetPoint
	bar.candyBarBar.SetPoint = function() end
	bar.candyBarBar:SetStatusBarTexture(BeautyWigs.media.texture) 
	if not bar.data["bigwigs:emphasized"] == true then
        if cfg.BigWigs.classcolor then 	
	       bar.candyBarBar:SetStatusBarColor(playercolor.r, playercolor.g, playercolor.b)
		end
		if cfg.BigWigs.customcolor then
		   bar.candyBarBar:SetStatusBarColor(unpack(cfg.BigWigs.barcolor))
		end 
    end
	-- setup icon positions and other things
	bar.candyBarIconFrame:ClearAllPoints()
	bar.candyBarIconFrame:SetPoint("BOTTOMLEFT", bar, "BOTTOMLEFT", -42, -1)
	bar.candyBarIconFrame:SetSize(cfg.BigWigs.buttonsize, cfg.BigWigs.buttonsize)
	bar.candyBarIconFrame.OldSetWidth = bar.candyBarIconFrame.SetWidth
	bar.candyBarIconFrame.SetWidth = function() end
	bar.candyBarIconFrame:SetTexCoord(0.08, 0.92, 0.08, 0.92)
end

local function registerStyle()
	if not BigWigs then return end
	local bars = BigWigs:GetPlugin("Bars", true)
	local prox = BigWigs:GetPlugin("Proximity", true)
	if bars then
		bars:RegisterBarStyle("BeautyWigs", {
			apiVersion = 1,
			version = 1,
			GetSpacing = function(bar) return cfg.BigWigs.buttonsize end,
			ApplyStyle = applystyle,
			BarStopped = freestyle,
			GetStyleName = function() return "BeautyWigs" end,
		})
	end
	if prox and cfg.BigWigs.BigWigs.skinrange and BigWigs.pluginCore.modules.Bars.db.profile.barStyle == "BeautyWigs" then
		hooksecurefunc(BigWigs.pluginCore.modules.Proximity, "RestyleWindow", function()
			CreateBorder(BigWigsProximityAnchor, 12, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1)
		end)
	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", function(self, event, msg)
	if event == "ADDON_LOADED" then
		if  msg == "BigWigs_Plugins" then	
			registerStyle()
			f:UnregisterEvent("ADDON_LOADED")
		end
	end
end)

local pr = function(msg)
    print("|cffC495DD!BeautyWigs|r:", tostring(msg))
end

SLASH_BEAUTYWIGS1 = "/beautybw"
SlashCmdList["BEAUTYWIGS"] = function(msg)
	if(msg == "apply") then
		SlashCmdList["BigWigs"]()
		HideUIPanel(InterfaceOptionsFrame)
		StaticPopup_Show("BEAUTYWIGS")        
	elseif(msg == "test") then
		SlashCmdList["BigWigs"]()
		BigWigs.pluginCore.modules.Proximity.Test(BigWigs.pluginCore.modules.Proximity)
		HideUIPanel(InterfaceOptionsFrame)
		BigWigs:Test()
		BigWigs:Test()
		BigWigs:Test()
		BigWigs:Test()
		BigWigs:Test()
	else
		pr("use |cffFF0000/beautybw apply|r to apply BigWigs settings.")
		pr("use |cffFF0000/beautybw test|r to launch BigWigs testmode.")
	end
end

local function Install()
	BigWigs.pluginCore.modules.Bars.db.profile.barStyle = "BeautyWigs"
	BigWigs.pluginCore.modules.Bars.db.profile.font = BeautyWigs.media.font
	BigWigs.pluginCore.modules.Messages.db.profile.font = BeautyWigs.media.font
	BigWigs.pluginCore.modules.Messages.db.profile.outline = "OUTLINE"
	BigWigs.pluginCore.modules.Proximity.db.profile.font = BeautyWigs.media.font
	if InCombatLockdown() then pr(ERR_NOT_IN_COMBAT) pr("Reload your UI to apply skin.") else ReloadUI() end
end

StaticPopupDialogs["BEAUTYWIGS"] = {
	text = "We need to set some BigWigs options to apply !BeautyWigs BigWigs skin.\nMost of your settings will remain untouched.",
	button1 = ACCEPT,
	button2 = CANCEL,
	OnAccept = Install,
	OnCancel = function() end,
    timeout = 0,
    whileDead = 1,
    hideOnEscape = true,
}

print("BobUI: Skinned BigWigs")